<?php
/*
 * This file is part of a larger software package. Please read the License file 
 * in the root of this installation for terms of usage and distribution.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * 
 * CORE: manage/dialog/website_user_modify.php - version 1.01
 * 1.02 - Updated to link to correct user login log table
*/

$nAdminOnlyPg = 1;

// Secure and connect
require("../../inc/dbconnect.php");
require("../inc/secure_page.php");

// bring in other required files
require("../inc/plugins.php");
require("../inc/pluginutil.php");

// Get passed-in variables
$webuser = (isset($_GET["wu"]) ? $_GET["wu"] : NULL);
if(!$webuser){ $webuser = (isset($_POST["wu"]) ? $_POST["wu"] : NULL); }

$nFirstName = $nLastName = $nLoginUser = $nLoginPass = $nWebsiteUserTypeID = $nEmail = $nNotes = "";
$nActive = "";

if($webuser){
	// Get information for this record to display
	$Query = "SELECT * FROM nWebsiteUser WHERE nID=$webuser";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	if($Row = mysql_fetch_array($Result)) {
		$nID = str_replace("\"","&quot;",$Row["nID"]);
		$nFirstName = str_replace("\"","&quot;",$Row["nFirstName"]);
		$nLastName = str_replace("\"","&quot;",$Row["nLastName"]);
		$nEmail = str_replace("\"","&quot;",$Row["nEmail"]);
		$nLoginUser = str_replace("\"","&quot;",$Row["nLoginUser"]);
		$nLoginPass = str_replace("\"","&quot;",$Row["nLoginPass"]);
		$nWebsiteUserTypeID = str_replace("\"","&quot;",$Row["nWebsiteUserTypeID"]);
		$nNotes = str_replace("\"","&quot;",$Row["nNotes"]);
		$nActive = $Row["nActive"];
	} else {
		exit("<li>You have requested a record that does not exist.  Please try again.</li>");
	}
}

// Formatting


// Defaults
if(!$webuser){
	$nWebsiteUserType = 1; // General
}
?>

<style>
#tabs .ui-tabs-panel{ height:392px; overflow:auto; }
</style>

<script>
// load orders
loadWebsiteUserLoginLog = function(){
	$('#userLog').html(loaderImgL).load('tables/website_user_login_log.php?wu=<?php echo urlencode($nLoginUser); ?>&m=m');
}
// initialize tabs
$(function() {
	<?php if($nLoginUser){ ?>loadWebsiteUserLoginLog();<?php } ?>
	$("#tabs").tabs();
});
</script>

<form action="../process_login.php" method="post" name="nLoginForm" id="nLoginForm" target="_blank" style="margin:0;"> 
	<input type="hidden" name="xRef" value=""> 
	<input type="hidden" name="nUser" value="<?php echo $nLoginUser?>">
	<input type="hidden" name="nPass" value="<?php echo $nLoginPass?>">
</form>

<?php
// Setup tabs
$nTabARRAY = array(); // tabID, position (leave blank for default tab)
$nTabARRAY["General"] = array("1",""); 
$nTabARRAY["Account"] = array("2","");
if($webuser){ $nTabARRAY["User Log"] = array("3",""); }

// Get plugin inclusion points for page, and insert them in all tabs
$nPluginListInclARRAY = nGetBackOfficePagePluginInclusions("ModifyWebsiteUser","",count($nTabARRAY)+1);
$nTabARRAY = nInsertPluginTabIncl($nPluginListInclARRAY,$nTabARRAY);

// get tabs and content
$nTabsCode = nBuildTabHTML($nTabARRAY);
$nTabsBodyCode = nBuildTabBodyHTML($nTabARRAY,"ModifyWebsiteUser");
?>

<div id="editModal" style="min-width:800px;">
		  	  
<div id="tabs">
	<ul>
		<?php echo $nTabsCode;?>
	</ul>
<?php echo $nTabsBodyCode;?>

<?php
// AJAX Specific vars
$nPassThru = "";
$nDivToUpdate = "editModal";
$nPageInDiv = "dialog/website_user_modify.php";

include("../inc/form_class.php");

$nFormName = "FormWebUserModify";
$nForm1 = new Form();
//$nForm1->DEBUG = true;
$nForm1->Name = $nFormName;
$nForm1->Action = $_SERVER['PHP_SELF'];
$nForm1->FormClass = "form no-border";
$nForm1->CancelText = "Cancel";
$nForm1->CancelRedirect = "dialogClose()";
$nForm1->CancelRedirectIsJS = true;
if($webuser){
	$nForm1->SubmitText = "Save Changes";
	$nForm1->ButtonTemplate = "<div class=\"clearfix grey-highlight\"><div class=\"input no-label\">[#Buttons#]<input type=\"button\" name=\"nDelete\" value=\" ".("Delete Website User")." \" class=\"button\" style=\"margin-left:160px;\" onClick=\"openDeleteDialog('webuser',$webuser,'Delete Website User');\"></input></div></div>\n";
} else {
	$nForm1->SubmitText = "Add Website User";
	$nForm1->ButtonTemplate = "<div class=\"clearfix grey-highlight\"><div class=\"input no-label\">[#Buttons#]</div></div>\n";
}
$nForm1->DBLink = $Link;
$nForm1->nUseADODB = false;
// AJAX settings
$nForm1->SubmitIsJS = true;
$nForm1->SubmitToJS = "return submitForm('$nDivToUpdate','$nPageInDiv$nPassThru','$nFormName');return false;";
$nForm1->DontProcess = "wu";
// Form styling
$nStandardFieldTemplate = "<div id=\"[#RowID#]\" class=\"clearfix [#RowClass#]\" style=\"[#RowStyle#]\">[#Label#]<div class=\"input\" style=\"[#ItemStyle#]\">[#BeforeField#][#Field#][#AfterField#]<span class=\"info\">[#Caption#]</span></div></div>\n";
$nAltFieldTemplate = "<div style=\"float:right; padding:0 0 0 40px;\">[#LabelRaw#] &nbsp; &nbsp; <span class=\"input\" style=\"[#ItemStyle#]\">[#BeforeField#][#Field#][#AfterField#]<span class=\"info\">[#Caption#]</span></span></div>\n";
$nForm1->CleanMarkup = true;
$nForm1->SubmitClass = "button blue";
$nForm1->CancelClass = "button";
$nForm1->FieldTemplate = $nStandardFieldTemplate;
$nForm1->GroupTemplate = "<div id=\"[#ID#]\" style=\"[#Style#]\" class=\"[#Class#]\">\n[#Name#][#FieldCode#]\n</div>\n";

// Create groups
$nFormGroup1 = new FormGroup();
$nFormGroup1->ID = "tabs-1";
$nFormGroup2 = new FormGroup();
$nFormGroup2->ID = "tabs-2";
$nFormGroup3 = new FormGroup();
$nFormGroup3->ID = "tabs-3";

// Create fields
$nFormField = new FormField("hidden","wu");
$nFormField->Value = $webuser;
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("text","nFirstName","First Name:");
$nFormField->Value = $nFirstName;
$nFormField->Class = "large";
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormField = $nForm1->AddValidation("maxlength",$nFormField,50);
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("text","nLastName","Last Name:");
$nFormField->Value = $nLastName;
$nFormField->Class = "large";
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormField = $nForm1->AddValidation("maxlength",$nFormField,50);
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("text","nEmail","E-mail Address:");
$nFormField->Value = $nEmail;
$nFormField->Class = "large";
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormField = $nForm1->AddValidation("maxlength",$nFormField,50);
$nFormField = $nForm1->AddValidation("email",$nFormField);
$nFormField = $nForm1->AddValidation("custom",$nFormField,"nVerifyEmailDuplicate");
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("select","nWebsiteUserTypeID","Website User Type:");
$nFormField->Class = "input";
$nFormField->DataARRAY = nGetWebsiteUserTypeIDARRAY();
$nFormField->SelectedARRAY = array("$nWebsiteUserTypeID" => "checked");
$nFormField->RowSize = "Half";
$nFormField->Title = _("User types let you group your website users to give more specific access to protected areas of your website.");
$nFormField->Rel = "tooltips";
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("select","nActive","Active?");
$nFormField->Class = "input";
$nFormField->DataARRAY = array(
	"1" => "Yes",
	"0" => "No");
$nFormField->SelectedARRAY = array("$nActive" => "checked");
$nFormField->RowSize = "Half";
$nFormField->Title = _("If set to 'No', this user will no longer be able to log in to their account on the site.");
$nFormField->Rel = "tooltips";
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormGroup1->AddField($nFormField);


// Account
$nFormField = new FormField("text","nLoginUser","Login Username:");
$nFormField->Value = $nLoginUser;
$nFormField->Class = "large";
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormField = $nForm1->AddValidation("maxlength",$nFormField,50);
$nFormField = $nForm1->AddValidation("custom",$nFormField,"nVerifyUserDuplicate");
$nFormGroup2->AddField($nFormField);

$nFormField = new FormField("password","nLoginPass","Login Password:");
$nFormField->Value = $nLoginPass;
$nFormField->Class = "large";
//$nFormField->Title = "Password is NOT case-sensitive.";
$nFormField->Rel = "tooltips";
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormField = $nForm1->AddValidation("maxlength",$nFormField,50);
$nFormGroup2->AddField($nFormField);

$nFormField = new FormField("textarea","nNotes","Account Notes:");
$nFormField->Value = $nNotes;
$nFormField->Class = "xlarge";
$nFormGroup2->AddField($nFormField);

// Order table
$nFormField = new FormField("static","","Login Attempts:");
$nFormField->Value = "<div id=\"userLog\" style=\"width:725px;\"></div>";
$nFormField->RowClass = "fullwidth";
$nFormGroup3->AddField($nFormField);

// Finalize and display form
$nForm1->AddGroup($nFormGroup1);
$nForm1->AddGroup($nFormGroup2);
if($webuser){ $nForm1->AddGroup($nFormGroup3); }
$nFormToDisplay = $nForm1->GetForm();

// AJAX redirect if form submitted w/o error, otherwise display form (again, if necessary)
if($nForm1->HasProcessed){
	// Post-processing
	$webuser = (isset($_POST["wu"]) ? $_POST["wu"] : NULL);
	$nID = (isset($_POST["nID"]) ? $_POST["nID"] : NULL);
	$nFirstName = (isset($_POST["nFirstName"]) ? $_POST["nFirstName"] : NULL);
	$nLastName = (isset($_POST["nLastName"]) ? $_POST["nLastName"] : NULL);
	$nEmail = (isset($_POST["nEmail"]) ? $_POST["nEmail"] : NULL);
	$nLoginUser = (isset($_POST["nLoginUser"]) ? $_POST["nLoginUser"] : NULL);
	$nLoginPass = (isset($_POST["nLoginPass"]) ? $_POST["nLoginPass"] : NULL);
	$nWebsiteUserTypeID = (isset($_POST["nWebsiteUserTypeID"]) ? $_POST["nWebsiteUserTypeID"] : NULL);
	$nNotes = (isset($_POST["nNotes"]) ? $_POST["nNotes"] : NULL);
	$nActive = (isset($_POST["nActive"]) ? $_POST["nActive"] : NULL);
	$nFullName = trim($nFirstName." ".$nLastName);
	
	// if record doesn't exist, create it now
	$nRecIsNew = false;
	if(!$webuser){
		$Query = "INSERT INTO nWebsiteUser (nFirstName,nLastName,nLoginUser,nLoginPass,nWebsiteUserTypeID,nNotes,nEmail,nActive) VALUES ('$nFirstName','$nLastName','$nLoginUser','$nLoginPass','$nWebsiteUserTypeID','$nNotes','$nEmail','$nActive')";
		mysql_select_db($DBName);
		mysql_query($Query,$Link);
		$webuser = mysql_insert_id();
		$nRecIsNew = true;
	} else {
		// update record
		$Query = "UPDATE nWebsiteUser SET nFirstName='$nFirstName',nLastName='$nLastName',nLoginUser='$nLoginUser',nLoginPass='$nLoginPass',nWebsiteUserTypeID='$nWebsiteUserTypeID',nNotes='$nNotes',nEmail='$nEmail',nActive='$nActive' WHERE nID=$webuser LIMIT 1";
		mysql_select_db($DBName);
		mysql_query($Query,$Link);
	}
	
	// log system event
	if($nRecIsNew){
		$nSystemEventDesc = "New website user (ID#$webuser) <strong>[nWebsiteUserID:$webuser]</strong> added.";
	} else {
		$nSystemEventDesc = "Website user (ID#$webuser) modified: <strong>[nWebsiteUserID:$webuser]</strong>";
	}
	$Query = "INSERT INTO nSystemEventLog (nEventTime,nEventDesc,nEditorUser) VALUES ('".date("Y-m-d H:i:s")."','$nSystemEventDesc','$ValidUser')";
	mysql_select_db($DBName); mysql_query($Query, $Link);
	
	// Refresh and close
	echo "<script>try{ nLoadWebsiteUsersTable(); }catch(e){}</script>";
	if($nRecIsNew){
		echo "<script>showNotify('A new website user <b>".addslashes($nFullName)."</b> was successfully added!','done'); dialogClose();</script>";
	} else {
		echo "<script>showNotify('The website user <b>".addslashes($nFullName)."</b> was successfully modified!','done'); dialogClose();</script>";
	}
	
} else {
	echo $nFormToDisplay;
	echo "<script>try{ activeDialog.resize(); }catch(e){}</script>";
	echo "<script>try{ $.colorbox.resize(); }catch(e){}</script>";
}
?>

</div>
</div>

</body>
</html>
<?php
function nVerifyUserDuplicate($nItemID){
	global $DBName,$Link,$webuser;
	if(!$nItemID){ return 0; }
	$nID = 0;
	$nItemID = addslashes(stripslashes($nItemID));
	$Query = "SELECT nID FROM nWebsiteUser WHERE nLoginUser='$nItemID'";
	if($webuser){ $Query = "SELECT nID FROM nWebsiteUser WHERE nLoginUser='$nItemID' AND nID!=$webuser"; }
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nID = $Row["nID"];
	}
	if($nID){ return 0; }
	return 1;
}
function nVerifyUserDuplicate_errormsg($nItemID){
	if(!$nItemID){ return _("Please enter a username before saving your changes."); }
	return "The username you entered, $nItemID, has already been used. Please try a different one.";
}
function nVerifyEmailDuplicate($nItemID){
	global $DBName,$Link,$webuser;
	if(!$nItemID){ return 0; }
	$nID = 0;
	$nItemID = addslashes(stripslashes($nItemID));
	$Query = "SELECT nID FROM nWebsiteUser WHERE nEmail='$nItemID'";
	if($webuser){ $Query = "SELECT nID FROM nWebsiteUser WHERE nEmail='$nItemID' AND nID!=$webuser"; }
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	if ($Row = mysql_fetch_array($Result)) {
		$nID = $Row["nID"];
	}
	if($nID){ return 0; }
	return 1;
}
function nVerifyEmailDuplicate_errormsg($nItemID){
	if(!$nItemID){ return _("Please enter an email before saving your changes."); }
	return "The email you entered, $nItemID, has already been used by another website user and cannot be used again.";
}
function nGetWebsiteUserTypeIDARRAY(){
	global $DBName, $Link;
	$nDataARRAY = array();
	$Query = "SELECT nID,nNameType FROM nWebsiteUserType";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nID = $Row["nID"];
		$nNameType = $Row["nNameType"];
		$nDataARRAY["$nID"] = "$nNameType";
	}
	return $nDataARRAY;
}
function nGetStateARRAY(){
	global $DBName, $Link;
	$nDataARRAY = array();
	$nDataARRAY[""] = "- Please choose -";
	$Query = "SELECT * FROM nStateInfo ORDER BY nState";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nAbbrev = $Row["nAbbrev"];
		$nState = $Row["nState"];
		$nDataARRAY["$nAbbrev"] = "$nState";
	}
	return $nDataARRAY;
}
function nGetCountryARRAY(){
	global $DBName, $Link;
	$nDataARRAY = array();
	$nDataARRAY[""] = "- Please choose -";
	$Query = "SELECT * FROM nCountryInfo";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nAbbrev = $Row["nAbbrev"];
		$nCountry = $Row["nCountry"];
		$nDataARRAY["$nAbbrev"] = "$nCountry";
	}
	return $nDataARRAY;
}
function formatPhone($nPhone){
	if($nPhone){ $nPhone = preg_replace("/\D/","",$nPhone); }
	// if 7 chars, format like this: ###-####
	if(strlen($nPhone)==7){ return substr($nPhone,0,3)."-".substr($nPhone,3,4); }
	// if 10 chars, format like this: (###)###-####
	if(strlen($nPhone)==10){ return "(".substr($nPhone,0,3).") ".substr($nPhone,3,3)."-".substr($nPhone,6,4); }
	// if 11 chars, format like this: #(###)###-####
	if(strlen($nPhone)==11){ return substr($nPhone,0,1)." (".substr($nPhone,1,3).") ".substr($nPhone,4,3)."-".substr($nPhone,7,4); }
	return $nPhone;
}
?>
<?php
// disconnect from mysql
mysql_close($Link);
?>

